<template>
  <div class="d-checkbox">
    <label v-if="isLabelVisible" v-html="label" />
    <vs-checkbox
      v-model="value"
      :classes="classes"
      :disabled="disabled"
      :style="styles"
      :vs-value="customOutputValue"
      @input="updateInput"
    >{{ title }}</vs-checkbox>
  </div>
</template>

<script>
export default {
  props: {
    disabled: {
      required: false,
      type: Boolean,
      default: false
    },
    label: {
      required: false,
      type: String,
      default: "&nbsp"
    },
    value: {
      required: false,
      type: [Object, Array, Number, String, Boolean],
      default: false
    },
    customOutputValue: {
      // what it will return us
      required: false,
      type: String,
      default: ""
    },
    title: {
      required: false,
      type: String,
      default: ""
    },
    classes: {
      required: false,
      type: String,
      default: ""
    },
    showLabel: {
      // for cases when we don't need to have label tag at all
      required: false,
      type: Boolean,
      default: true
    },
    showLabelOnMobile: {
      // for cases when we don't need to have label tag at all on mobile
      required: false,
      type: Boolean,
      default: true
    },
    styles: {
      required: false,
      type: String,
      default: ""
    }
  },
  computed: {
    isLabelVisible() {
      if (this.isMobile) {
        return this.showLabelOnMobile;
      } else {
        return this.showLabel;
      }
    },
    isMobile() {
      return screen.width < 576;
    }
  },
  methods: {
    updateInput() {
      this.$emit("input", this.value);
    }
  }
};
</script>

<style lang="scss">
@import "@/assets/scss/vuexy/_variables.scss";

.d-checkbox {
  // .vs-input-primary .vs-input--input:focus {
  // 	border-color: $d-input-focus-color !important;
  // }
  label {
    font-size: $d-input-label-size;
    padding-left: $d-input-label-padding;
  }

  .in-error {
    color: red !important;
  }
}
</style>
